#include "gd32f10x.h"
#include "boot.h"
#include "main.h"
#include "delay.h"
#include "fmc.h"
#include "w25q32.h"
#include <stdio.h>
#include "ota_message.h"
#define APP_PROGRAMMER_BLOCK 2   //W25Q32дŵλ

load_a load_A;       

//bootloader
void BootLoader_Brance(uint32_t download_byte)
{
	GD32_EraseFlash(GD32_A_START_PAGE,GD32_A_PAGE_NUM);//Aԭг
	for(uint8_t i=0;i<download_byte/GD32_PAGE_SIZE;i++)
	{
		task_fwdgt_reload();
		uint8_t app_programmer[GD32_PAGE_SIZE];
		memset(app_programmer,0,GD32_PAGE_SIZE);
		FLASH_Read(GD32_D_SADDR,app_programmer,GD32_PAGE_SIZE);              
		FLASH_Write(GD32_A_SADDR+i*GD32_PAGE_SIZE,(uint16_t *)&app_programmer,GD32_PAGE_SIZE/2);	//ݰҳд
	}
	//1024ݵд
	if(download_byte%GD32_PAGE_SIZE!=0)
	{
		uint32_t startAddress=(download_byte/GD32_PAGE_SIZE)*GD32_PAGE_SIZE;
		uint8_t app_programmer[GD32_PAGE_SIZE];
		uint32_t addr=GD32_D_SADDR+startAddress;   														//w25q32еĵַ
		memset(app_programmer,0,GD32_PAGE_SIZE);
		FLASH_Read(addr,app_programmer,GD32_PAGE_SIZE);              
		FLASH_Write(GD32_A_SADDR+startAddress,(uint16_t *)&app_programmer,GD32_PAGE_SIZE/2);	//ݰҳд
	}
	clear_ota_message_config_block();  
	LOAD_A(GD32_A_SADDR);
}


/*-------------------------------------------------*/
/*SP                                   */
/*  addrջָʼֵ                     */
/*ֵ                                       */
/*-------------------------------------------------*/
__asm void MSR_SP(uint32_t addr)
{
	MSR MSP, r0      
	BX r14             
}
/*-------------------------------------------------*/
/*תA                                */
/*  addrAʼַ                      */
/*ֵ                                       */
/*-------------------------------------------------*/
void LOAD_A(uint32_t addr)
{
	if((*(uint32_t *)addr>=0x20000000)&&(*(uint32_t *)addr<=0x20017FFF)){     
		MSR_SP(*(uint32_t *)addr);                                            
		load_A = (load_a)*(uint32_t *)(addr+4);                               
		BootLoader_Clear();                                                
		load_A();                                       
	}else ; 
}
/*-------------------------------------------------*/
/*Bʹõ                        */
/*                                         */
/*ֵ                                       */
/*-------------------------------------------------*/
void BootLoader_Clear(void)
{
	gpio_deinit(GPIOA);    
	gpio_deinit(GPIOB);    
}













