#include "gd32f10x.h"
#include "fmc.h"


/*--------------------------------------------------*/
/*ҳFLASH     							 */
/*  startʼҳ   numҳ    		   */
/*ֵ                                         */
/*
flashṹ
0x08000000~0x0807FFFF   bank02KBһҳ0~255ҳ256ҳ512KB
0x08080000~0x082FFFFF   bank14KBһҳ256~895ҳ640ҳ2.5MB	ڴҪʱ
*/
/*-------------------------------------------------*/
void GD32_EraseFlash(uint16_t start, uint16_t num)
{
	uint16_t i;        //forѭ
	uint16_t j = 0;        

	if ((start <= 896) && (start + num) > 896)
	{
		num = 896 - start;
	}
	else if (start > 896)
	{
		return;
	}

	fmc_unlock();                                                       //
	if ((start < 256) && ((start + num) < 256))
	{
		for(i = 0; i < num; i++)										//ѭnumΣһҳһҳĲ
		{
			fmc_page_erase((0x08000000 + start * 2048) + (2048 * i));   //bank0һҳ2KB
		}
	}
	else if ((start < 256) && ((start + num) > 256))
	{
		for(i = 0; i < num; i++)										//ѭnumΣһҳһҳĲ
		{
			if((start + i) < 256)
			{
				fmc_page_erase((0x08000000 + start * 2 * 1024) + (2 * 1024 * i));       //bank0һҳ2KB
			}
			else
			{
				fmc_page_erase(0x08080000 + (4 * 1024 * j));       //bank1һҳ4KB
				j++;
			}
		}
	}
	else if (start > 256)
	{
		for(i = 0; i < num; i++)										//ѭnumΣһҳһҳĲ
		{
			fmc_page_erase((0x08080000 + (start - 256) * 4 * 1024) + (4 * 1024 * i));   //bank1һҳ4KB
		}
	}
	
	fmc_lock();                                                         //
} 
/*---------------------------------------------------------------------*/
/*дFLASH                                                    */
/*  saddrдַ wdataдָ  wnumдٸֽ    */
/*ֵ                                                           */
/*---------------------------------------------------------------------*/
void GD32_WriteFlash(uint32_t saddr, uint32_t *wdata, uint32_t wnum)
{
	fmc_unlock();                          //
	while(wnum){                           //ѭд룬֪num0˳whileʾд
		fmc_word_program(saddr,*wdata);    //дһ֣4ֽڣ
		wnum-=4;                           //дֽ-4
		saddr+=4;                          //дַ+4
		wdata++;                           //дݵָ룬Ųһ
	}
	fmc_lock();                            //
}


// /**
//  * @brief ȡflash
//  * 
//  * @param rbuff ջ
//  * @param addr ʼַ32λַ
//  * @param datalen ݳȣٸֽ
//  */
// void GD32_ReadFlash(uint8_t *rbuff, uint32_t addr, uint32_t datalen)
// {
// 	memcpy(rbuff,addr,datalen);
// }


__align(4) static uint16_t FlashBuffer[GD32FLASH_PAGE_SIZE >> 1];

/// ʼFLASH
void FLASH_Init(void)
{
    fmc_unlock();
    fmc_flag_clear(FMC_FLAG_BANK0_END);
    fmc_flag_clear(FMC_FLAG_BANK0_WPERR);
    fmc_flag_clear(FMC_FLAG_BANK0_PGERR);
    fmc_lock();
}

/**
 * FLASH
 * @param  Address ַ
 * @param  Buffer  Ŷȡ
 * @param  Size    ҪȡݴСλֽ
 * @return         ɹֽ
 */
uint32_t FLASH_Read(uint32_t Address, void *Buffer, uint32_t Size)
{
    uint32_t nread = Size;
    uint8_t* d = (uint8_t *)Buffer;
    const uint8_t* s = (const uint8_t *)Address;

    if (!Buffer || Address < GD32FLASH_BASE || Address >= GD32FLASH_END)
        return 0;

    while (nread >= sizeof(uint32_t) && (((uint32_t)s) <= (GD32FLASH_END - 4)))
    {
        *(volatile uint32_t *)d = *(volatile uint32_t *)s;
        d += sizeof(uint32_t);
        s += sizeof(uint32_t);
        nread -= sizeof(uint32_t);
    }

    while (nread && (((uint32_t)s) < GD32FLASH_END))
    {
        *d++ = *s++;
        nread--;
    }

    return Size - nread;
}

/**
 * дFLASH
 * @param  Address    дʼַҪ2ֽڶ룡
 * @param  Buffer     дݣҪ2ֽڶ룡
 * @param  NumToWrite Ҫдλ֣Ҫ2ֽڶ룡
 * @return            ʵдλֽ
 */
uint32_t FLASH_Write(uint32_t Address, const uint16_t *Buffer, uint32_t NumToWrite)
{
    uint32_t i = 0;
    uint32_t pagepos = 0;         // ҳλ
    uint32_t pageoff = 0;         // ҳƫƵַ
    uint32_t pagefre = 0;         // ҳڿռ
    uint32_t offset = 0;          // AddressFLASHеƫ
    uint32_t nwrite = NumToWrite; // ¼ʣҪд
    const uint16_t *pBuffer = (const uint16_t *)Buffer;

    /* Ƿַ */
    if (Address < GD32FLASH_BASE || Address > (GD32FLASH_END - 2) || NumToWrite == 0 || pBuffer == NULL)
        return 0;

    /* FLASH */
    fmc_unlock();

    /* ƫƵַ */
    offset = Address - GD32FLASH_BASE;

    /* 㵱ǰҳλ */
    pagepos = offset / GD32FLASH_PAGE_SIZE;

    /* ҪдݵʼַڵǰҳڵƫƵַ */
    pageoff = ((offset % GD32FLASH_PAGE_SIZE) >> 1);

    /* 㵱ǰҳڿռ */
    pagefre = ((GD32FLASH_PAGE_SIZE >> 1) - pageoff);

    /* Ҫдڵǰҳ */
    if (nwrite <= pagefre)
        pagefre = nwrite;

    while (nwrite != 0)
    {
        /* Ƿҳ */
        if (pagepos >= GD32FLASH_PAGE_NUM)
            break;

        /* ȡһҳ */
        FLASH_Read(GD32FLASH_BASE + pagepos * GD32FLASH_PAGE_SIZE, FlashBuffer, GD32FLASH_PAGE_SIZE);

        /* ǷҪ */
        for (i = 0; i < pagefre; i++)
        {
            if (*(FlashBuffer + pageoff + i) != 0xFFFF) /* FLASHĬȫΪ0xFF */
                break;
        }

        if (i < pagefre)
        {
            uint32_t count = 0;
            uint32_t index = 0;

            if(FLASH_ErasePage(GD32FLASH_BASE + pagepos * GD32FLASH_PAGE_SIZE, 1) < 0)
                break;

            /* Ƶ */
            for (index = 0; index < pagefre; index++)
            {
                *(FlashBuffer + pageoff + index) = *(pBuffer + index);
            }

            /* дFLASH */
            count = FLASH_WriteNotErase(GD32FLASH_BASE + pagepos * GD32FLASH_PAGE_SIZE, FlashBuffer, GD32FLASH_PAGE_SIZE >> 1);
            if (count != (GD32FLASH_PAGE_SIZE >> 1))
            {
                nwrite -= count;
                break;
            }
        }
        else
        {
            /* ֱд */
            uint32_t count = FLASH_WriteNotErase(Address, pBuffer, pagefre);
            if (count != pagefre)
            {
                nwrite -= count;
                break;
            }
        }

        pBuffer += pagefre;         /* ȡַ         */
        Address += (pagefre << 1);  /* дַ         */
        nwrite -= pagefre;          /* ʣδд */

        pagepos++;     /* һҳ           */
        pageoff = 0;   /* ҳƫƵַ  */

        /* ʣ´д */
        pagefre = nwrite >= (GD32FLASH_PAGE_SIZE >> 1) ? (GD32FLASH_PAGE_SIZE >> 1) : nwrite;
    }

    /* FLASH */
    fmc_lock();

    return ((NumToWrite - nwrite) << 1);
}

uint32_t FLASH_WriteNotErase(uint32_t Address, const uint16_t *Buffer, uint32_t NumToWrite)
{
    uint32_t nwrite = NumToWrite;
    uint32_t addrmax = GD32FLASH_END - 2;

    while (nwrite)
    {
        if (Address > addrmax)
            break;

        fmc_halfword_program(Address, *Buffer);
        
        if ((*(__IO uint16_t*) Address) != *Buffer)
            break;

        nwrite--;
        Buffer++;
        Address += 2;
    }
    return (NumToWrite - nwrite);
}

int FLASH_ErasePage(uint32_t PageAddress, uint32_t NbPages)
{
    while(NbPages--)
    {
        if(fmc_page_erase(PageAddress) != FMC_READY)
        {
            return -1;
        }
        PageAddress += GD32FLASH_PAGE_SIZE;
    }
    return 0;
}
